package org.mosad.seil0.projectlaogai

import android.content.Intent
import android.graphics.Color
import android.os.Bundle
import android.text.Html
import android.view.View
import android.widget.LinearLayout
import android.widget.TextView
import androidx.appcompat.app.AppCompatActivity
import androidx.viewpager.widget.ViewPager
import kotlinx.android.synthetic.main.activity_onboarding.*
import org.mosad.seil0.projectlaogai.fragments.SettingsFragment
import org.mosad.seil0.projectlaogai.onboarding.ViewPagerAdapter


class OnboardingActivity : AppCompatActivity() {

    companion object {
        val layouts = intArrayOf(R.layout.fragment_on_welcome, R.layout.fragment_on_course) //, R.layout.fragment_on_login)
    }
    private lateinit var viewPager: ViewPager
    private lateinit var viewPagerAdapter: ViewPagerAdapter
    private lateinit var linLayoutDots: LinearLayout
    private lateinit var dots: Array<TextView>

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_onboarding)

        viewPager = findViewById(R.id.viewPager)
        linLayoutDots = findViewById(R.id.linLayout_Dots)

        addBottomDots(0)

        viewPagerAdapter = ViewPagerAdapter(this)
        viewPager.adapter = viewPagerAdapter
        viewPager.addOnPageChangeListener(viewPagerPageChangeListener)

        btn_Skip.visibility = View.GONE // without the the skip button is visible
    }

    fun btnNextClick(v: View) {
        if (viewPager.currentItem < layouts.size - 1) {
            viewPager.currentItem++
        } else {
            launchHomeScreen()
        }
    }

    fun btnSkipClick(v: View) {
        launchHomeScreen()
    }

    fun btnSelectCourseClick(v: View) {
        SettingsFragment().selectCourse(this) // TODO
    }

    private fun addBottomDots(currentPage: Int) {
        dots = Array(layouts.size) { TextView(this) }
        linLayoutDots.removeAllViews()

        dots.forEach {
            it.text = Html.fromHtml("&#8226;")
            it.textSize = 35f
            it.setTextColor(Color.parseColor("#cccccc"))
            linLayoutDots.addView(it)
        }

        if (dots.isNotEmpty())
            dots[currentPage].setTextColor(Color.parseColor("#000000"))
    }

    private fun launchHomeScreen() {
        startActivity(Intent(this, MainActivity::class.java))
        //finish()
    }

    private var viewPagerPageChangeListener: ViewPager.OnPageChangeListener = object : ViewPager.OnPageChangeListener {

        override fun onPageSelected(position: Int) {
            addBottomDots(position)
            // changing the next button text
            if (position == layouts.size - 1) {
                btn_Next.text = getString(R.string.start)
                btn_Next.visibility = View.VISIBLE
                btn_Skip.visibility = View.GONE
            } else {
                btn_Next.visibility = View.GONE
                btn_Skip.visibility = View.GONE
            }
        }

        override fun onPageScrolled(arg0: Int, arg1: Float, arg2: Int) {}
        override fun onPageScrollStateChanged(arg0: Int) {}
    }


}